SystemOrganization addCategory: #'Deltawerken-Framework'!

Object subclass: #DEApplicationDescription
	instanceVariableNames: 'applicationClass libraryClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Framework'!

DEApplicationDescription class
	instanceVariableNames: 'singleton'!

DEApplicationDescription class
	instanceVariableNames: 'singleton'!

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 13:32'!
applicationCategory
	^self category, '-Web'! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 11:33'!
applicationClassName
	^self prefix, self applicationName, 'Application'! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 13:20'!
applicationName
	^'Deltawerken'! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 11:33'!
libraryClassName
	^self prefix, 'FileLibrary'! !

!DEApplicationDescription class methodsFor: 'code generation' stamp: 'DiegoLont 4/4/2012 14:15'!
newApplication: aName prefix: aPrefix catagory: aCategory
	| descriptionClass |
	SystemOrganization addCategory: aCategory.
	descriptionClass := (ClassBuilder new) superclass: self subclass: (aPrefix, 'ApplicationDescription') asSymbol instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: aCategory.
	descriptionClass class compile: (String streamContents: [ :s |
		s nextPutAll: 'prefix'; lf;
		tab; nextPutAll: '^'''; nextPutAll: aPrefix; nextPut: $' ]) classified: 'accessing'.
	descriptionClass class compile: (String streamContents: [ :s |
		s nextPutAll: 'applicationName'; lf;
		tab; nextPutAll: '^'''; nextPutAll: aName; nextPut: $' ]) classified: 'accessing'.
	descriptionClass singleton applicationClass initialize! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 13:19'!
prefix
	^'DE'! !

!DEApplicationDescription class methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 11:44'!
regenerate
	self singleton regenerate! !

!DEApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:05'!
singleton
	^singleton ifNil: [ singleton := self new ]! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:17'!
applicationCategory
	^self class applicationCategory! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 11:34'!
applicationClass
	^applicationClass ifNil: [ applicationClass := self generateApplicationClass ]! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:17'!
applicationClassName
	^self class applicationClassName! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:17'!
applicationName
	^self class applicationName! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 11:57'!
generateApplicationClass
	| retVal |
	self libraryClass.
	retVal := (ClassBuilder new) superclass: WAComponent subclass: self applicationClassName asSymbol instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: self applicationCategory.
	self generateApplicationMethodsTo: retVal.
	^retVal! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 12:00'!
generateApplicationMethodsTo: aClass
	aClass class compile: (String streamContents: [ :s |
		s nextPutAll: 'initialize'; lf;
			tab; nextPutAll: '"Registers this application as webpage"'; lf;
			tab; nextPutAll: 'super initialize.'; lf;
			tab; nextPutAll: '(WAAdmin register: self asApplicationAt: '''; nextPutAll: self applicationName asLowercase; nextPutAll: ''')'; lf;
			tab; tab; nextPutAll: 'addLibrary: JQDeploymentLibrary;'; lf;
			tab; tab; nextPutAll: 'addLibrary: JQUiDeploymentLibrary' ]) classified: 'initialization'.
	aClass class compile: (String streamContents: [ :s |
		s nextPutAll: 'canBeRoot'; lf;
			tab; nextPutAll: '^true' ]) classified: 'testing'.
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: 'title'; lf;
			tab; nextPutAll: '^'''; nextPutAll: self applicationName; nextPut: $' ]) classified: 'accessing'.
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: 'updateRoot: anHtmlRoot'; lf;
			tab; nextPutAll: 'super updateRoot: anHtmlRoot.'; lf;
			tab; nextPutAll: 'anHtmlRoot title: self title.'; lf;
			tab; nextPutAll: 'anHtmlRoot link'; lf;
			tab; tab; nextPutAll: 'type: ''text/css'';'; lf;
			tab; tab; nextPutAll: 'beStylesheet;'; lf;
			tab; tab; nextPutAll: 'addAll;'; lf;
			tab; tab; nextPutAll: 'url: '; nextPutAll: self libraryClassName; nextPutAll: ' / ''main.css''' ]) classified: 'rendering'.
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: 'renderContentOn: canvas'; lf;
			tab; nextPutAll: 'canvas heading: '''; nextPutAll: self applicationName; nextPut: $'; lf;
			tab; nextPutAll: '"Insert your custom rendering code here"' ]) classified: 'rendering'! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 11:32'!
generateLibraryClass
	| retVal |
	SystemOrganization addCategory: self applicationCategory.
	retVal := (ClassBuilder new) superclass: WAFileLibrary subclass: self libraryClassName asSymbol instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: self applicationCategory.
	self generateLibraryMethodsTo: retVal! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 11:35'!
generateLibraryMethodsTo: aClass
	aClass compile: (String streamContents: [ :s |
		s nextPutAll: 'mainCss'; lf;
			tab; nextPutAll: '^''''']) classified: 'css'! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 11:59'!
libraryClass
	^libraryClass ifNil: [ libraryClass := self generateLibraryClass ]! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 11:29'!
libraryClassName
	^self class libraryClassName! !

!DEApplicationDescription methodsFor: 'accessing' stamp: 'DiegoLont 4/4/2012 14:18'!
prefix
	^self class prefix! !

!DEApplicationDescription methodsFor: 'code generation' stamp: 'DiegoLont 4/11/2012 11:59'!
regenerate
	applicationClass := nil.
	libraryClass := nil.
	self applicationClass initialize! !
